 simulation<-function(g,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3){
	
	sim_data=NULL
for(i in 1:(g*p1)){
	
	sim_data=rbind(sim_data,rnorm(30,mean=mean1,sd=sigma1))
	
}

for(i in 1:(g*p2)){
	
	sim_data=rbind(sim_data,rnorm(30,mean=mean2,sd=sigma2))
	
}
for(i in 1:(g*p3)){
	
	sim_data=rbind(sim_data,rnorm(30,mean=mean3,sd=sigma3))
	
}


genes=NULL
for(i in 1:g){
	genes=c(genes,paste("G",i,sep=""))
	
}
samples=NULL
for(i in 1:n){
	samples=c(samples,paste("S",i,sep=""))
	
}

row.names(sim_data)=genes
colnames(sim_data)=samples


return(sim_data)
}




 
library(mclust)	
BIC_100<-function(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3,G){
	V_bic=NULL
	E_bic=NULL
	m=NULL
	good=NULL
	for(i in 1:100){
	 print(i)
	 sim1=simulation(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3)
	 genes=row.names(sim1)
	 sim_sd=apply(sim1,1,function(x) sd(x))
	 V=NULL
	 E=NULL
	 for(g in 2:G){
	 	
	 	V=c(V,Mclust(sim_sd,G=g,modelNames="V")$bic)
	 	E=c(E,Mclust(sim_sd,G=g,modelNames="E")$bic)
	 	
	 	
	 }
	 e=Mclust(sim_sd,G=3,modelNames="V")
	 m=rbind(m,e$parameters$mean)
	 grp1=names(which(e$classification==1))
	 grp2=names(which(e$classification==2))
	 grp3=names(which(e$classification==3))
	 l1=gene*p1
	 l2=(gene*p1)+(gene*p2)
	 l3=gene
	good=rbind(good, c(sum(grp1 %in% genes[1:l1]),sum(grp2 %in% genes[(l1+1):l2]),sum(grp3 %in% genes[(l2+1):l3])))

	 V_bic=rbind(V_bic,V)
	 E_bic=rbind(E_bic,E)
	 
	 }
	 
	 return(list(V_bic=V_bic,E_bic=E_bic,m=m,good=good))
	 }
	 
	 BIC_100_mad<-function(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3,G){
	V_bic=NULL
	E_bic=NULL
	m=NULL
	good=NULL
	for(i in 1:100){
	 print(i)
	 sim1=simulation(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3)
	 genes=row.names(sim1)
	 sim_mad=apply(sim1,1,function(x) mad(x))
	 V=NULL
	 E=NULL
	 for(g in 2:G){
	 	
	 	V=c(V,Mclust(sim_mad,G=g,modelNames="V")$bic)
	 	E=c(E,Mclust(sim_mad,G=g,modelNames="E")$bic)
	 	
	 	
	 }
	 e=Mclust(sim_mad,G=3,modelNames="V")
	 m=rbind(m,e$parameters$mean)
	 grp1=names(which(e$classification==1))
	 grp2=names(which(e$classification==2))
	 grp3=names(which(e$classification==3))
	 l1=gene*p1
	 l2=(gene*p1)+(gene*p2)
	 l3=gene
	good=rbind(good, c(sum(grp1 %in% genes[1:l1]),sum(grp2 %in% genes[(l1+1):l2]),sum(grp3 %in% genes[(l2+1):l3])))

	 V_bic=rbind(V_bic,V)
	 E_bic=rbind(E_bic,E)
	 
	 }
	 
	 return(list(V_bic=V_bic,E_bic=E_bic,m=m,good=good))
	 }

	 
	 
	  covar<-function(x){
	cv=sd(x)/mean(x)
	return(cv)
}

BIC_100_cv<-function(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3,G){
	V_bic=NULL
	E_bic=NULL
	m=NULL
	good=NULL
	for(i in 1:100){
	 print(i)
	 sim1=simulation(gene,n,p1,p2,p3,mean1,mean2,mean3,sigma1,sigma2,sigma3)
	 genes=row.names(sim1)
	 sim_cv=apply(sim1,1,function(x) covar(x))
	 V=NULL
	 E=NULL
	 for(g in 2:G){
	 	
	 	V=c(V,Mclust(sim_cv,G=g,modelNames="V")$bic)
	 	E=c(E,Mclust(sim_cv,G=g,modelNames="E")$bic)
	 	
	 	
	 }
	 e=Mclust(sim_cv,G=3,modelNames="V")
	 m=rbind(m,e$parameters$mean)
	 grp1=names(which(e$classification==1))
	 grp2=names(which(e$classification==2))
	 grp3=names(which(e$classification==3))
	 l1=gene*p1
	 l2=(gene*p1)+(gene*p2)
	 l3=gene
	good=rbind(good, c(sum(grp1 %in% genes[1:l1]),sum(grp2 %in% genes[(l1+1):l2]),sum(grp3 %in% genes[(l2+1):l3])))

	 V_bic=rbind(V_bic,V)
	 E_bic=rbind(E_bic,E)
	 
	 }
	 
	 return(list(V_bic=V_bic,E_bic=E_bic,m=m,good=good))
	 }
	 



	 

essai_2=BIC_100(9999,30,1/3,1/3,1/3,9,9,9,1,sqrt(2),sqrt(3),4)

par(mfrow=c(2,2))
boxplot(cbind(essai_2$V_bic,essai_2$E_bic),names=c("2-V","3-V","4-V","2-E","3-E","4-E"),ylab="BIC")
mis=cbind(3333-essai_2$good[,1],3333-essai_2$good[,2],3333-essai_2$good[,3])
boxplot(mis,names=c("Low","Medium","High"),ylab="Misclassification")

#best is 2
plot(1:100,essai_2$V_bic[,1],ylab="BIC",xlab="Simulation number",col="green",ylim=c(-6600,-5600))
points(1:100,essai_2$V_bic[,2],col="black")
points(1:100,essai_2$V_bic[,3],col="red")
leg.txt=c("2","3","4")
legend(locator(1),pch=1,col=c("green","black","red"),legend=leg.txt,title="# of components")
#best is 2
plot(density(essai_2$V_bic[,1]),xlab="BIC",main="",col="green")
lines(density(essai_2$V_bic[,2]),col="black")
lines(density(essai_2$V_bic[,3]),col="red")
legend(locator(1),lty=1,col=c("green","black","red"),legend=leg.txt,title="# of components")

#3 components not better than 2 compoennts
sum(essai_2$V_bic[,2]>essai_2$V_bic[,1])#13
sum(essai_2$V_bic[,2]>essai_2$V_bic[,3])#100



 sim2=simulation(9999,30,1/3,1/3,1/3,9,9,9,1,sqrt(2),sqrt(3))
 sim_sd_2=apply(sim2,1,function(x) sd(x))
 e2=Mclust(sim_sd_2)
 summary(e2)#best 2V
 
  mis_sd=rowSums(mis)
mean(mis_sd)#2130.72
sd(mis_sd)#43.15841

 
essai_mad_2=BIC_100_mad(9999,30,1/3,1/3,1/3,9,9,9,1,sqrt(2),sqrt(3),5)	


par(mfrow=c(2,2))
boxplot(cbind(essai_mad_2$V_bic,essai_mad_2$E_bic),names=c("2-V","3-V","4-V","5-V","2-E","3-E","4-E","5-E"),ylab="BIC")
mis=cbind(3333-essai_mad_2$good[,1],3333-essai_mad_2$good[,2],3333-essai_mad_2$good[,3])
boxplot(mis,names=c("Low","Medium","High"),ylab="Misclassification")


#best is 3
plot(1:100,essai_mad_2$V_bic[,2],ylab="BIC",xlab="Simulation number",ylim=c(-10400,-9400))
points(1:100,essai_mad_2$V_bic[,3],col="red")
points(1:100,essai_mad_2$V_bic[,4],col="blue")
leg.txt=c("3","4","5")
legend(locator(1),pch=1,col=c("black","red","blue"),legend=leg.txt,title="# of components")
#best is 3
plot(density(essai_mad_2$V_bic[,2]),xlab="BIC",main="")
lines(density(essai_mad_2$V_bic[,3]),col="red")
lines(density(essai_mad_2$V_bic[,4]),col="blue")
legend(locator(1),lty=1,col=c("black","red","blue"),legend=leg.txt,title="# of components")

##3 components nearly always better that 4 and 5 except 3 times for 4 components

sum(essai_mad_2$V_bic[,2]>essai_mad_2$V_bic[,3])#97
sum(essai_mad_2$V_bic[,2]>essai_mad_2$V_bic[,4])#100


 sim_mad_2=apply(sim2,1,function(x) mad(x))
 e2_mad=Mclust(sim_mad_2)
 summary(e2_mad)#best 3 V
 mis_mad=rowSums(mis)
mean(mis_mad)#3538.47
sd(mis_mad)# 47.66878


essai_cv_2=BIC_100_cv(9999,30,1/3,1/3,1/3,9,9,9,1,sqrt(2),sqrt(3),5)	
 par(mfrow=c(2,2))

boxplot(cbind(essai_cv_2$V_bic,essai_cv_2$E_bic),names=c("2-V","3-V","4-V","5-V","2-E","3-E","4-E","5-E"),ylab="BIC")
mis=cbind(3333-essai_cv_2$good[,1],3333-essai_cv_2$good[,2],3333-essai_cv_2$good[,3])
boxplot(mis,names=c("Low","Medium","High"),ylab="Misclassification")

#best is 3
plot(1:100,essai_cv_2$V_bic[,1],ylab="BIC",xlab="Simulation number",col="green",ylim=c(37200,38000))
points(1:100,essai_cv_2$V_bic[,2],col="black")
points(1:100,essai_cv_2$V_bic[,3],col="red")
leg.txt=c("2","3","4")
legend(locator(1),pch=1,col=c("green","black","red"),legend=leg.txt,title="# of components")

#best is 3
plot(density(essai_cv_2$V_bic[,1]),col="green",xlab="BIC",main="")
lines(density(essai_cv_2$V_bic[,2]),col="black")
lines(density(essai_cv_2$V_bic[,3]),col="red")
legend(locator(1),lty=1,col=c("green","black","red"),legend=leg.txt,title="# of components")

#3 components not better than 2
sum(essai_cv_2$V_bic[,2]>essai_cv_2$V_bic[,1])#4
sum(essai_cv_2$V_bic[,2]>essai_cv_2$V_bic[,3])#100

 sim_cv_2=apply(sim2,1,function(x) covar(x))
 e2_cv=Mclust(sim_cv_2)
 summary(e2_cv)#best 2 V
 mis_cv=rowSums(mis)
mean(mis_cv)# 2186.8
sd(mis_cv)#38.24535
save.image("sim_p2_m1_v2.RData")


